
;CodeVisionAVR C Compiler V2.04.9a Evaluation
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : float, width, precision
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _adc_isr
	RJMP 0x00
	RJMP _ana_comp_isr
	RJMP 0x00
	RJMP 0x00

_0x3:
	.DB  0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8
	.DB  0x80,0x90,0xFF
_0x4:
	.DB  0x87,0x8C
_0x5:
	.DB  0x0,0x0,0x77,0x1,0x45

__GLOBAL_INI_TBL:
	.DW  0x0B
	.DW  _dig
	.DW  _0x3*2

	.DW  0x02
	.DW  _mode
	.DW  _0x4*2

	.DW  0x05
	.DW  _t
	.DW  _0x5*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/****************************************************
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;
;// ADC interrupt service routine
;// with auto input scanning
;interrupt [ADC_INT] void adc_isr(void);
;
;// Analog Comparator interrupt service routine
;interrupt [ANA_COMP] void ana_comp_isr(void);
;
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void);
;
;// External Interrupt 1 service routine
;interrupt [EXT_INT1] void ext_int1_isr(void);
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void);
;
;// Timer1 overflow interrupt service routine
;interrupt [TIM1_OVF] void timer1_ovf_isr(void);
;
;// Timer2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void);
;
;// Declare your global variables here
;volatile unsigned int adc_data;
;volatile unsigned char dig[11]={192,249,164,176,153,146,130,248,128,144,255},ind[3]={0,0,0},indcnt=0,mode[2]={135,140};

	.DSEG
;volatile unsigned char vcd=0,tm2c=0,vcd_c=0,vcd_f=0,off=0,ph=0,pl=0,frz=0,frz_tm=0,frz_tm_f=0,ind_tmp=0;
;volatile unsigned short t[3]={0,375,69},vcd_tm=0,p=0,t_frz=0,adc_d=0,adc_c=0;
;__eeprom unsigned short tmp_m;
;__eeprom unsigned char p_m;
;
;void main(void)
; 0000 002D {

	.CSEG
_main:
; 0000 002E // Declare your local variables here
; 0000 002F 
; 0000 0030 // Input/Output Ports initialization
; 0000 0031 // Port B initialization
; 0000 0032 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0033 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 0034 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0035 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 0036 
; 0000 0037 // Port C initialization
; 0000 0038 // Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In
; 0000 0039 // State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=T
; 0000 003A PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 003B DDRC=0x3E;
	LDI  R30,LOW(62)
	OUT  0x14,R30
; 0000 003C 
; 0000 003D // Port D initialization
; 0000 003E // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 003F // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0040 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0041 DDRD=0x00;
	OUT  0x11,R30
; 0000 0042 
; 0000 0043 // Timer/Counter 0 initialization
; 0000 0044 // Clock source: System Clock
; 0000 0045 // Clock value: 8,000 000 kHz
; 0000 0046 TCCR0=0x00;
	RCALL SUBOPT_0x0
; 0000 0047 TCNT0=0x00;
; 0000 0048 
; 0000 0049 // Timer/Counter 1 initialization
; 0000 004A // Clock source: System Clock
; 0000 004B // Clock value: Timer1 Stopped
; 0000 004C // Mode: Normal top=0xFFFF
; 0000 004D // OC1A output: Discon.
; 0000 004E // OC1B output: Discon.
; 0000 004F // Noise Canceler: Off
; 0000 0050 // Input Capture on Falling Edge
; 0000 0051 // Timer1 Overflow Interrupt: Off
; 0000 0052 // Input Capture Interrupt: Off
; 0000 0053 // Compare A Match Interrupt: Off
; 0000 0054 // Compare B Match Interrupt: Off
; 0000 0055 TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 0056 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0057 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0058 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0059 ICR1H=0x00;
	OUT  0x27,R30
; 0000 005A ICR1L=0x00;
	OUT  0x26,R30
; 0000 005B OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 005C OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 005D OCR1BH=0x00;
	OUT  0x29,R30
; 0000 005E OCR1BL=0x00;
	OUT  0x28,R30
; 0000 005F 
; 0000 0060 // Timer/Counter 2 initialization
; 0000 0061 // Clock source: System Clock
; 0000 0062 // Clock value: 7,813 kHz
; 0000 0063 // Mode: Normal top=0xFF
; 0000 0064 // OC2 output: Disconnected
; 0000 0065 ASSR=0x00;
	OUT  0x22,R30
; 0000 0066 TCCR2=0x00;
	OUT  0x25,R30
; 0000 0067 TCNT2=0x00;
	OUT  0x24,R30
; 0000 0068 OCR2=0x00;
	OUT  0x23,R30
; 0000 0069 
; 0000 006A // External Interrupt(s) initialization
; 0000 006B // INT0: On
; 0000 006C // INT0 Mode: Rising Edge
; 0000 006D // INT1: On
; 0000 006E // INT1 Mode: Rising Edge
; 0000 006F GICR|=0xC0;
	IN   R30,0x3B
	ORI  R30,LOW(0xC0)
	OUT  0x3B,R30
; 0000 0070 MCUCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x35,R30
; 0000 0071 GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
; 0000 0072 
; 0000 0073 
; 0000 0074 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0075 TIMSK=0x45;
	LDI  R30,LOW(69)
	OUT  0x39,R30
; 0000 0076 
; 0000 0077 // ADC initialization
; 0000 0078 // ADC Clock frequency: 125,000 kHz
; 0000 0079 // ADC Voltage Reference: Int., cap. on AREF
; 0000 007A ADMUX=0xc0 & 0xff;
	LDI  R30,LOW(192)
	OUT  0x7,R30
; 0000 007B ADCSRA=0xCE;
	LDI  R30,LOW(206)
	OUT  0x6,R30
; 0000 007C 
; 0000 007D // Analog Comparator initialization
; 0000 007E // Analog Comparator: On
; 0000 007F // The Analog Comparator's positive input is
; 0000 0080 // connected to the Bandgap Voltage Reference
; 0000 0081 // Interrupt on Rising Output Edge
; 0000 0082 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0083 ACSR=0x4B;
	LDI  R30,LOW(75)
	OUT  0x8,R30
; 0000 0084 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0085 
; 0000 0086 // Global enable interrupts
; 0000 0087 #asm("sei")
	sei
; 0000 0088 
; 0000 0089 t[1]=tmp_m;
	LDI  R26,LOW(_tmp_m)
	LDI  R27,HIGH(_tmp_m)
	RCALL __EEPROMRDW
	__PUTW1MN _t,2
; 0000 008A if(t[1]>500){t[1]=0;};
	__GETW2MN _t,2
	CPI  R26,LOW(0x1F5)
	LDI  R30,HIGH(0x1F5)
	CPC  R27,R30
	BRLO _0x6
	__POINTW1MN _t,2
	RCALL SUBOPT_0x1
_0x6:
; 0000 008B 
; 0000 008C t[2]=p_m;
	LDI  R26,LOW(_p_m)
	LDI  R27,HIGH(_p_m)
	RCALL __EEPROMRDB
	__POINTW2MN _t,4
	RCALL SUBOPT_0x2
	ST   X+,R30
	ST   X,R31
; 0000 008D if(t[2]>100){t[2]=0;};
	__GETW2MN _t,4
	CPI  R26,LOW(0x65)
	LDI  R30,HIGH(0x65)
	CPC  R27,R30
	BRLO _0x7
	__POINTW1MN _t,4
	RCALL SUBOPT_0x1
_0x7:
; 0000 008E 
; 0000 008F TCCR2=0x05;  // Clock value: 62.500 kHz
	LDI  R30,LOW(5)
	OUT  0x25,R30
; 0000 0090 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0091 
; 0000 0092 while (1)
_0x8:
; 0000 0093       {
; 0000 0094            t_frz=(adc_data*1.1)-437.29;
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x3F8CCCCD
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x43DAA51F
	RCALL __SWAPD12
	RCALL __SUBF12
	LDI  R26,LOW(_t_frz)
	LDI  R27,HIGH(_t_frz)
	RCALL __CFD1U
	ST   X+,R30
	ST   X,R31
; 0000 0095        //    t_frz=adc_data;
; 0000 0096            if(frz==1){t[0]=t[1];}          //    +-5
	LDS  R26,_frz
	CPI  R26,LOW(0x1)
	BRNE _0xB
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
; 0000 0097            else{if(frz_tm_f==1){t[0]=t_frz;frz_tm_f=0;frz_tm_f=0;};};
	RJMP _0xC
_0xB:
	LDS  R26,_frz_tm_f
	CPI  R26,LOW(0x1)
	BRNE _0xD
	LDS  R30,_t_frz
	LDS  R31,_t_frz+1
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x5
_0xD:
_0xC:
; 0000 0098 
; 0000 0099                   p=312-(t[2]*3.12);
	RCALL SUBOPT_0x6
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x4047AE14
	RCALL __MULF12
	__GETD2N 0x439C0000
	RCALL __SWAPD12
	RCALL __SUBF12
	LDI  R26,LOW(_p)
	LDI  R27,HIGH(_p)
	RCALL __CFD1U
	ST   X+,R30
	ST   X,R31
; 0000 009A                   if(t[2]==101){t[2]=100;};
	RCALL SUBOPT_0x6
	CPI  R30,LOW(0x65)
	LDI  R26,HIGH(0x65)
	CPC  R31,R26
	BRNE _0xE
	__POINTW1MN _t,4
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	STD  Z+0,R26
	STD  Z+1,R27
_0xE:
; 0000 009B                   if(t[2]==65535){t[2]=0;};
	RCALL SUBOPT_0x6
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0xF
	__POINTW1MN _t,4
	RCALL SUBOPT_0x1
_0xF:
; 0000 009C 
; 0000 009D                   if(t[1]==500){t[1]=500;};
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x1F4)
	LDI  R26,HIGH(0x1F4)
	CPC  R31,R26
	BRNE _0x10
	__POINTW1MN _t,2
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	STD  Z+0,R26
	STD  Z+1,R27
_0x10:
; 0000 009E                   if(t[1]==65535){t[1]=0;};
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x11
	__POINTW1MN _t,2
	RCALL SUBOPT_0x1
_0x11:
; 0000 009F 
; 0000 00A0                   ph=255-(p/256);
	LDS  R30,_p+1
	ANDI R31,HIGH(0x0)
	LDI  R26,LOW(255)
	LDI  R27,HIGH(255)
	RCALL __SWAPW12
	RCALL SUBOPT_0x7
	STS  _ph,R30
; 0000 00A1                   pl=256-(p-256);
	LDS  R30,_p
	LDS  R31,_p+1
	SUBI R30,LOW(256)
	SBCI R31,HIGH(256)
	LDI  R26,LOW(256)
	LDI  R27,HIGH(256)
	RCALL __SWAPW12
	RCALL SUBOPT_0x7
	STS  _pl,R30
; 0000 00A2       }
	RJMP _0x8
; 0000 00A3 }
_0x12:
	RJMP _0x12
;
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 00A6 {
_ext_int1_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00A7 PORTC.1=0;
	CBI  0x15,1
; 0000 00A8 
; 0000 00A9 if(off==0)
	LDS  R30,_off
	CPI  R30,0
	BRNE _0x15
; 0000 00AA {
; 0000 00AB       if(t_frz<t[1])
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x8
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x16
; 0000 00AC       {
; 0000 00AD         if(t_frz>(t[1]-5)){frz=1;}
	RCALL SUBOPT_0x3
	SBIW R30,5
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	BRSH _0x17
	LDI  R30,LOW(1)
	RJMP _0x5F
; 0000 00AE         else{frz=0;};
_0x17:
	LDI  R30,LOW(0)
_0x5F:
	STS  _frz,R30
; 0000 00AF 
; 0000 00B0         if(t_frz>=(t[1]-10))
	RCALL SUBOPT_0x3
	SBIW R30,10
	RCALL SUBOPT_0x8
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x19
; 0000 00B1         {
; 0000 00B2          TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 00B3          TCNT1H=255;
	LDI  R30,LOW(255)
	OUT  0x2D,R30
; 0000 00B4          TCNT1L=216;
	LDI  R30,LOW(216)
	OUT  0x2C,R30
; 0000 00B5         }
; 0000 00B6          else{PORTC.1=1;};
	RJMP _0x1A
_0x19:
	SBI  0x15,1
_0x1A:
; 0000 00B7      }
; 0000 00B8 else
	RJMP _0x1D
_0x16:
; 0000 00B9      {
; 0000 00BA        if(t_frz<(t[1]+5)){frz=1;}
	RCALL SUBOPT_0x3
	ADIW R30,5
	RCALL SUBOPT_0x8
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x1E
	LDI  R30,LOW(1)
	RJMP _0x60
; 0000 00BB        else{frz=0;};
_0x1E:
	LDI  R30,LOW(0)
_0x60:
	STS  _frz,R30
; 0000 00BC      };
_0x1D:
; 0000 00BD }
; 0000 00BE else
	RJMP _0x20
_0x15:
; 0000 00BF   {
; 0000 00C0        if (t[2]==100){PORTC.1=1;}
	RCALL SUBOPT_0x6
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRNE _0x21
	SBI  0x15,1
; 0000 00C1        else
	RJMP _0x24
_0x21:
; 0000 00C2      {
; 0000 00C3        if (t[2]!=0)
	RCALL SUBOPT_0x6
	SBIW R30,0
	BREQ _0x25
; 0000 00C4         {
; 0000 00C5           TCCR1B=0x04;
	LDI  R30,LOW(4)
	OUT  0x2E,R30
; 0000 00C6           TCNT1H=ph;
	LDS  R30,_ph
	OUT  0x2D,R30
; 0000 00C7           TCNT1L=pl;
	LDS  R30,_pl
	OUT  0x2C,R30
; 0000 00C8        };
_0x25:
; 0000 00C9      };
_0x24:
; 0000 00CA   };
_0x20:
; 0000 00CB }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 00CD {
_ext_int0_isr:
; 0000 00CE 
; 0000 00CF }
	RETI
;
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 00D2 {
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00D3 TCCR2=0x05; // Clock value: 125,000 kHz
	LDI  R30,LOW(5)
	OUT  0x25,R30
; 0000 00D4 TCNT2=230;
	LDI  R30,LOW(230)
	OUT  0x24,R30
; 0000 00D5   if ((((PIND.4)*2)+PIND.2)!=vcd)
	RCALL SUBOPT_0xA
	ADD  R26,R30
	LDS  R30,_vcd
	LDI  R27,0
	SBRC R26,7
	SER  R27
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x9
	BRNE PC+2
	RJMP _0x26
; 0000 00D6   {
; 0000 00D7      vcd_c++;
	LDS  R30,_vcd_c
	SUBI R30,-LOW(1)
	STS  _vcd_c,R30
; 0000 00D8      if(vcd_c==4)
	LDS  R26,_vcd_c
	CPI  R26,LOW(0x4)
	BREQ PC+2
	RJMP _0x27
; 0000 00D9    {
; 0000 00DA      vcd_c=0;
	LDI  R30,LOW(0)
	STS  _vcd_c,R30
; 0000 00DB      if(off==0){vcd_f=1;};
	LDS  R30,_off
	CPI  R30,0
	BRNE _0x28
	LDI  R30,LOW(1)
	RCALL SUBOPT_0xB
_0x28:
; 0000 00DC            switch (((PIND.4)*2)+PIND.2)
	RCALL SUBOPT_0xA
	ADD  R30,R26
; 0000 00DD            {
; 0000 00DE             case 0:  if(vcd==1){++t[vcd_f];}
	CPI  R30,0
	BRNE _0x2C
	LDS  R26,_vcd
	CPI  R26,LOW(0x1)
	BRNE _0x2D
	RCALL SUBOPT_0xC
	ADIW R30,1
	RJMP _0x61
; 0000 00DF                      else{--t[vcd_f];};
_0x2D:
	RCALL SUBOPT_0xC
	SBIW R30,1
_0x61:
	ST   -X,R31
	ST   -X,R30
; 0000 00E0                      break;
	RJMP _0x2B
; 0000 00E1             case 1:  if(vcd==3){++t[vcd_f];}
_0x2C:
	CPI  R30,LOW(0x1)
	BRNE _0x2F
	LDS  R26,_vcd
	CPI  R26,LOW(0x3)
	BRNE _0x30
	RCALL SUBOPT_0xC
	ADIW R30,1
	RJMP _0x62
; 0000 00E2                      else{--t[vcd_f];};
_0x30:
	RCALL SUBOPT_0xC
	SBIW R30,1
_0x62:
	ST   -X,R31
	ST   -X,R30
; 0000 00E3                      break;
	RJMP _0x2B
; 0000 00E4             case 2:  if(vcd==0){++t[vcd_f];}
_0x2F:
	CPI  R30,LOW(0x2)
	BRNE _0x32
	LDS  R30,_vcd
	CPI  R30,0
	BRNE _0x33
	RCALL SUBOPT_0xC
	ADIW R30,1
	RJMP _0x63
; 0000 00E5                      else{--t[vcd_f];};
_0x33:
	RCALL SUBOPT_0xC
	SBIW R30,1
_0x63:
	ST   -X,R31
	ST   -X,R30
; 0000 00E6                      break;
	RJMP _0x2B
; 0000 00E7             case 3:  if(vcd==2){++t[vcd_f];}
_0x32:
	CPI  R30,LOW(0x3)
	BRNE _0x2B
	LDS  R26,_vcd
	CPI  R26,LOW(0x2)
	BRNE _0x36
	RCALL SUBOPT_0xC
	ADIW R30,1
	RJMP _0x64
; 0000 00E8                      else{--t[vcd_f];};
_0x36:
	RCALL SUBOPT_0xC
	SBIW R30,1
_0x64:
	ST   -X,R31
	ST   -X,R30
; 0000 00E9                      break;
; 0000 00EA            };
_0x2B:
; 0000 00EB    };
_0x27:
; 0000 00EC     vcd_tm=0;               //   
	RCALL SUBOPT_0xD
; 0000 00ED     vcd=((PIND.4)*2)+PIND.2;
	RCALL SUBOPT_0xA
	ADD  R30,R26
	STS  _vcd,R30
; 0000 00EE   };
_0x26:
; 0000 00EF 
; 0000 00F0    tm2c++;
	LDS  R30,_tm2c
	SUBI R30,-LOW(1)
	STS  _tm2c,R30
; 0000 00F1    if(tm2c==5)
	LDS  R26,_tm2c
	CPI  R26,LOW(0x5)
	BREQ PC+2
	RJMP _0x38
; 0000 00F2    {
; 0000 00F3    tm2c=0;
	LDI  R30,LOW(0)
	STS  _tm2c,R30
; 0000 00F4 
; 0000 00F5           if(adc_data==1023) {off=1;vcd_f=2;}
	LDS  R26,_adc_data
	LDS  R27,_adc_data+1
	CPI  R26,LOW(0x3FF)
	LDI  R30,HIGH(0x3FF)
	CPC  R27,R30
	BRNE _0x39
	LDI  R30,LOW(1)
	STS  _off,R30
	LDI  R30,LOW(2)
	RCALL SUBOPT_0xB
; 0000 00F6           else
	RJMP _0x3A
_0x39:
; 0000 00F7           {
; 0000 00F8           if(off==1){off=0;vcd_f=0;vcd_tm=0;};
	LDS  R26,_off
	CPI  R26,LOW(0x1)
	BRNE _0x3B
	LDI  R30,LOW(0)
	STS  _off,R30
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xD
_0x3B:
; 0000 00F9           if(vcd_f==1){vcd_tm++;if(vcd_tm==1500){vcd_f=0;vcd_tm=0;};};
	LDS  R26,_vcd_f
	CPI  R26,LOW(0x1)
	BRNE _0x3C
	LDI  R26,LOW(_vcd_tm)
	LDI  R27,HIGH(_vcd_tm)
	RCALL SUBOPT_0xE
	LDS  R26,_vcd_tm
	LDS  R27,_vcd_tm+1
	CPI  R26,LOW(0x5DC)
	LDI  R30,HIGH(0x5DC)
	CPC  R27,R30
	BRNE _0x3D
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xD
_0x3D:
_0x3C:
; 0000 00FA           };
_0x3A:
; 0000 00FB 
; 0000 00FC                     ind[2]=t[vcd_f]/100;
	RCALL SUBOPT_0xF
	RCALL __GETW1P
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	__PUTB1MN _ind,2
; 0000 00FD                     ind_tmp=t[vcd_f]-(ind[2]*100);
	RCALL SUBOPT_0xF
	LD   R22,X+
	LD   R23,X
	__GETB2MN _ind,2
	LDI  R30,LOW(100)
	RCALL SUBOPT_0x10
	STS  _ind_tmp,R30
; 0000 00FE                     ind[1]=ind_tmp/10;
	LDS  R26,_ind_tmp
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	__PUTB1MN _ind,1
; 0000 00FF                     ind[0]=ind_tmp-(ind[1]*10);
	LDS  R22,_ind_tmp
	CLR  R23
	__GETB2MN _ind,1
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x10
	STS  _ind,R30
; 0000 0100 
; 0000 0101                     if(ind[2]==0){ind[2]=10;};
	__GETB1MN _ind,2
	CPI  R30,0
	BRNE _0x3E
	LDI  R30,LOW(10)
	__PUTB1MN _ind,2
_0x3E:
; 0000 0102                     if(ind[1]==0){if(ind[2]==10){ind[1]=10;};};
	__GETB1MN _ind,1
	CPI  R30,0
	BRNE _0x3F
	__GETB2MN _ind,2
	CPI  R26,LOW(0xA)
	BRNE _0x40
	LDI  R30,LOW(10)
	__PUTB1MN _ind,1
_0x40:
_0x3F:
; 0000 0103 
; 0000 0104 
; 0000 0105         switch (indcnt)
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x2
; 0000 0106            {
; 0000 0107             case 0:  PORTC.2=0;
	SBIW R30,0
	BRNE _0x44
	CBI  0x15,2
; 0000 0108                      PORTC.5=1;
	SBI  0x15,5
; 0000 0109                      PORTB=mode[off];
	LDS  R30,_off
	RCALL SUBOPT_0x2
	SUBI R30,LOW(-_mode)
	SBCI R31,HIGH(-_mode)
	RCALL SUBOPT_0x12
; 0000 010A                      indcnt++;
	RJMP _0x65
; 0000 010B                      break;
; 0000 010C             case 1:  PORTC.5=0;
_0x44:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x49
	CBI  0x15,5
; 0000 010D                      PORTC.4=1;
	SBI  0x15,4
; 0000 010E                      PORTB=dig[ind[0]];
	LDS  R30,_ind
	RCALL SUBOPT_0x13
; 0000 010F                      indcnt++;
	RJMP _0x65
; 0000 0110                      break;
; 0000 0111             case 2:  PORTC.4=0;
_0x49:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x4E
	CBI  0x15,4
; 0000 0112                      PORTC.3=1;
	SBI  0x15,3
; 0000 0113                      PORTB=dig[ind[1]];
	__GETB1MN _ind,1
	RCALL SUBOPT_0x13
; 0000 0114                      indcnt++;
	RJMP _0x65
; 0000 0115                      break;
; 0000 0116             case 3:  PORTC.3=0;
_0x4E:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x43
	CBI  0x15,3
; 0000 0117                      PORTC.2=1;
	SBI  0x15,2
; 0000 0118                      PORTB=dig[ind[2]];
	__GETB1MN _ind,2
	RCALL SUBOPT_0x2
	SUBI R30,LOW(-_dig)
	SBCI R31,HIGH(-_dig)
	LD   R30,Z
	OUT  0x18,R30
; 0000 0119                      indcnt=0;
	LDI  R30,LOW(0)
_0x65:
	STS  _indcnt,R30
; 0000 011A                      break;
; 0000 011B 
; 0000 011C            };
_0x43:
; 0000 011D    }
; 0000 011E }
_0x38:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0121 {
_timer0_ovf_isr:
; 0000 0122 
; 0000 0123 }
	RETI
;
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 0126 {
_timer1_ovf_isr:
	ST   -Y,R30
; 0000 0127 PORTC.1=1;
	SBI  0x15,1
; 0000 0128 TCCR0=0x00;
	RCALL SUBOPT_0x0
; 0000 0129 TCNT0=0x00;
; 0000 012A }
	LD   R30,Y+
	RETI
;
;interrupt [ANA_COMP] void ana_comp_isr(void)
; 0000 012D {
_ana_comp_isr:
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 012E if(tmp_m!=t[1]){tmp_m=t[1];};
	LDI  R26,LOW(_tmp_m)
	LDI  R27,HIGH(_tmp_m)
	RCALL __EEPROMRDW
	MOVW R26,R30
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x9
	BREQ _0x5A
	RCALL SUBOPT_0x3
	LDI  R26,LOW(_tmp_m)
	LDI  R27,HIGH(_tmp_m)
	RCALL __EEPROMWRW
_0x5A:
; 0000 012F if(p_m!=t[2]){p_m=t[2];};
	LDI  R26,LOW(_p_m)
	LDI  R27,HIGH(_p_m)
	RCALL __EEPROMRDB
	MOV  R26,R30
	RCALL SUBOPT_0x6
	LDI  R27,0
	RCALL SUBOPT_0x9
	BREQ _0x5B
	__GETB1MN _t,4
	LDI  R26,LOW(_p_m)
	LDI  R27,HIGH(_p_m)
	RCALL __EEPROMWRB
_0x5B:
; 0000 0130 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	RETI
;
;interrupt [ADC_INT] void adc_isr(void)
; 0000 0133 {
_adc_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0134 ADMUX=0xc0 & 0xff;
	LDI  R30,LOW(192)
	OUT  0x7,R30
; 0000 0135 // Delay needed for the stabilization of the ADC input voltage
; 0000 0136 if(adc_c==10)
	LDS  R26,_adc_c
	LDS  R27,_adc_c+1
	SBIW R26,10
	BRNE _0x5C
; 0000 0137 {
; 0000 0138 adc_c=0;
	LDI  R30,LOW(0)
	STS  _adc_c,R30
	STS  _adc_c+1,R30
; 0000 0139 adc_data=adc_d/10;
	RCALL SUBOPT_0x14
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	STS  _adc_data,R30
	STS  _adc_data+1,R31
; 0000 013A adc_d=0;
	LDI  R30,LOW(0)
	STS  _adc_d,R30
	STS  _adc_d+1,R30
; 0000 013B 
; 0000 013C frz_tm++;
	LDS  R30,_frz_tm
	SUBI R30,-LOW(1)
	STS  _frz_tm,R30
; 0000 013D if(frz_tm==255){frz_tm_f=1;frz_tm=0;}   //   
	LDS  R26,_frz_tm
	CPI  R26,LOW(0xFF)
	BRNE _0x5D
	LDI  R30,LOW(1)
	STS  _frz_tm_f,R30
	LDI  R30,LOW(0)
	STS  _frz_tm,R30
; 0000 013E else{frz_tm_f=0;};
	RJMP _0x5E
_0x5D:
	RCALL SUBOPT_0x5
_0x5E:
; 0000 013F };
_0x5C:
; 0000 0140 adc_d=ADCW+adc_d;
	IN   R30,0x4
	IN   R31,0x4+1
	RCALL SUBOPT_0x14
	ADD  R30,R26
	ADC  R31,R27
	STS  _adc_d,R30
	STS  _adc_d+1,R31
; 0000 0141 adc_c++;
	LDI  R26,LOW(_adc_c)
	LDI  R27,HIGH(_adc_c)
	RCALL SUBOPT_0xE
; 0000 0142 // Start the AD conversion
; 0000 0143 ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0144 
; 0000 0145 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI

	.DSEG
_adc_data:
	.BYTE 0x2
_dig:
	.BYTE 0xB
_ind:
	.BYTE 0x3
_indcnt:
	.BYTE 0x1
_mode:
	.BYTE 0x2
_vcd:
	.BYTE 0x1
_tm2c:
	.BYTE 0x1
_vcd_c:
	.BYTE 0x1
_vcd_f:
	.BYTE 0x1
_off:
	.BYTE 0x1
_ph:
	.BYTE 0x1
_pl:
	.BYTE 0x1
_frz:
	.BYTE 0x1
_frz_tm:
	.BYTE 0x1
_frz_tm_f:
	.BYTE 0x1
_ind_tmp:
	.BYTE 0x1
_t:
	.BYTE 0x6
_vcd_tm:
	.BYTE 0x2
_p:
	.BYTE 0x2
_t_frz:
	.BYTE 0x2
_adc_d:
	.BYTE 0x2
_adc_c:
	.BYTE 0x2

	.ESEG
_tmp_m:
	.BYTE 0x2
_p_m:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x33,R30
	OUT  0x32,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1:
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:30 WORDS
SUBOPT_0x2:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x3:
	__GETW1MN _t,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	STS  _t,R30
	STS  _t+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(0)
	STS  _frz_tm_f,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x6:
	__GETW1MN _t,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x8:
	LDS  R26,_t_frz
	LDS  R27,_t_frz+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0xA:
	LDI  R26,0
	SBIC 0x10,4
	LDI  R26,1
	LDI  R30,LOW(2)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R26,R30
	LDI  R30,0
	SBIC 0x10,2
	LDI  R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	STS  _vcd_f,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:68 WORDS
SUBOPT_0xC:
	LDS  R30,_vcd_f
	LDI  R26,LOW(_t)
	LDI  R27,HIGH(_t)
	RCALL SUBOPT_0x2
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(0)
	STS  _vcd_tm,R30
	STS  _vcd_tm+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xF:
	LDS  R30,_vcd_f
	LDI  R26,LOW(_t)
	LDI  R27,HIGH(_t)
	RCALL SUBOPT_0x2
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	MUL  R30,R26
	MOVW R30,R0
	MOVW R26,R30
	MOVW R30,R22
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LDS  R30,_indcnt
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x12:
	LD   R30,Z
	OUT  0x18,R30
	RCALL SUBOPT_0x11
	SUBI R30,-LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	RCALL SUBOPT_0x2
	SUBI R30,LOW(-_dig)
	SBCI R31,HIGH(-_dig)
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	LDS  R26,_adc_d
	LDS  R27,_adc_d+1
	RET


	.CSEG
__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
